#pragma once
#include "Midi.h"
#include <utility>

class Launchpad
{
public:
	typedef void (*KeyEventCallback)(unsigned char x, unsigned char y);

protected:
	MidiIn midiin;
	MidiOut midiout;

public:
	KeyEventCallback keyPressedCallback;
	KeyEventCallback keyReleasedCallback;

	Launchpad();

protected:
	void keyPressed(unsigned char x, unsigned char y);
	void keyReleased(unsigned char x, unsigned char y);

private:
	static void midiMessageCallback(double timeStamp, MidiMessage &message, void *launchpad);
};
